#include <bits/stdc++.h>

using namespace std;

int a[500000],b[500000],br=0;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cerr.tie(0);
    int n,k,i,j,zlj=0,indx=-1,mm=0;
    cin>>n>>k;
    for(i=0;i<n;i++){
        cin>>a[i];
        if(a[i]>1){
            zlj=1;
        }
    }
    if(zlj==1){
        i=0;
        while(i<n-k){
            mm=a[i];
            indx=i;
            for(j=i;j<i+k+1;j++){
                if(mm>a[j]){
                    mm=a[j];
                    indx=j;
                }
            }
            b[br]=a[indx];
            br++;
            k=k-indx+i;
            i=indx+1;
        }
    }

    for(i=0;i<br;i++){
        cout<<b[i]<<" ";
    }
    return 0;
}